## wxpython4.0 4.0.1+dfsg

=== requirements.txt ===
# Phoenix build and test requirements
appdirs
setuptools
six
wheel
twine
sphinx
requests
pytest
pytest-xdist
pytest-timeout
numpy

=== wscript ===
#!/usr/bin/python
#-----------------------------------------------------------------------------
#  WAF script for building and installing the wxPython extension modules.
#
# Author:      Robin Dunn
# Copyright:   (c) 2013 - 2017 by Total Control Software
# License:     wxWindows License
#-----------------------------------------------------------------------------

import sys
import os

import buildtools.config
cfg = buildtools.config.Config(True)

#-----------------------------------------------------------------------------
# Options and configuration

APPNAME = 'wxPython'
VERSION = cfg.VERSION

isWindows = sys.platform.startswith('win')
isDarwin = sys.platform == "darwin"

top = '.'
out = 'build/waf'


def options(opt):
    if isWindows:
        opt.load('msvc')
    else:
        opt.load('compiler_cc compiler_cxx')
    opt.load('python')

    opt.add_option('--debug', dest='debug', action='store_true', default=False,
                   help='Turn on debugger-related compile options.')
    opt.add_option('--python', dest='python', default='', action='store',
                   help='Full path to the Python executable to use.')
    opt.add_option('--wx_config', dest='wx_config', default='wx-config', action='store',
                   help='Full path to the wx-config script to be used for this build.')
    opt.add_option('--no_magic', dest='no_magic', action='store_true', default=False,
                   help='Don\'t use linker magic to enable wx libs to be bundled with '
                   'wxPython.  See build.py for more info.')
    opt.add_option('--mac_arch', dest='mac_arch', default='', action='store',
                   help='One or more comma separated architecture names to be used for '
                   'the Mac builds. Should be at least a subset of the architectures '
                   'used by wxWidgets and Python')
    opt.add_option('--gtk2', dest='gtk2', action='store_true', default=False,
                   help='On Linux build for gtk2 (default gtk3)')
    opt.add_option('--gtk3', dest='gtk3', action='store_true', default=True,
                   help='On Linux build for gtk3')
    opt.add_option('--msvc_arch', dest='msvc_arch', default='x86', action='store',
                   help='The architecture to target for MSVC builds. Supported values '
                   'are: "x86" or "x64"')
    #opt.add_option('--msvc_ver', dest='msvc_ver', default='9.0', action='store',
    #               help='The MSVC version to use for the build, if multiple versions are '
    #               'installed. Currently supported values are: "9.0" or "10.0"')

    # TODO: The waf msvc tool has --msvc_version and --msvc_target options
    # already. We should just switch to those instead of adding our own
    # option names...

    opt.add_option('--msvc_relwithdebug', dest='msvc_relwithdebug', action='store_true', default=False,
                   help='Turn on debug info for release builds for MSVC builds.')



def configure(conf):
    if isWindows:
        # For now simply choose the compiler version based on the Python
        # version. We have a chicken-egg problem here. The compiler needs to
        # be selected before the Python stuff can be configured, but we need
        # Python to know what version of the compiler to use.
        import distutils.msvc9compiler
        msvc_version = str( distutils.msvc9compiler.get_build_version() )
        conf.env['MSVC_VERSIONS'] = ['msvc ' + msvc_version]
        conf.env['MSVC_TARGETS'] = [conf.options.msvc_arch]
        conf.load('msvc')
    else:
        conf.load('compiler_cc compiler_cxx')

    if conf.options.python:
        conf.env.PYTHON = conf.options.python
    conf.load('python')
    conf.check_python_version(minver=(2,7,0))
    if isWindows:
        # Search for the Python headers without doing some stuff that could
        # incorrectly fail on Windows. See my_check_python_headers below.
        conf.my_check_python_headers()
    else:
        conf.check_python_headers()

    # fetch and save the debug options
    conf.env.debug = conf.options.debug
    conf.env.msvc_relwithdebug = conf.options.msvc_relwithdebug

    # Ensure that the headers in siplib and Phoenix's src dir can be found
    conf.env.INCLUDES_WXPY = ['sip/siplib', 'src']

    if isWindows:
        # Windows/MSVC specific stuff

        cfg.finishSetup(debug=conf.env.debug)

        conf.env.INCLUDES_WX = cfg.includes
        conf.env.DEFINES_WX = cfg.wafDefines
        conf.env.CFLAGS_WX = cfg.cflags
        conf.env.CXXFLAGS_WX = cfg.cflags
        conf.env.LIBPATH_WX = cfg.libdirs
        conf.env.LIB_WX = cfg.libs
        conf.env.LIBFLAGS_WX = cfg.lflags

        _copyEnvGroup(conf.env, '_WX', '_WXADV')
        conf.env.LIB_WXADV += cfg.makeLibName('adv')

        _copyEnvGroup(conf.env, '_WX', '_WXSTC')
        conf.env.LIB_WXSTC += cfg.makeLibName('stc')

        _copyEnvGroup(conf.env, '_WX', '_WXHTML')
        conf.env.LIB_WXHTML += cfg.makeLibName('html')

        _copyEnvGroup(conf.env, '_WX', '_WXGL')
        conf.env.LIB_WXGL += cfg.makeLibName('gl')

        _copyEnvGroup(conf.env, '_WX', '_WXWEBVIEW')
        conf.env.LIB_WXWEBVIEW += cfg.makeLibName('webview')

        _copyEnvGroup(conf.env, '_WX', '_WXXML')
        conf.env.LIB_WXXML += cfg.makeLibName('xml', isMSWBase=True)

        _copyEnvGroup(conf.env, '_WX', '_WXXRC')
        conf.env.LIB_WXXRC += cfg.makeLibName('xrc')

        _copyEnvGroup(conf.env, '_WX', '_WXRICHTEXT')
        conf.env.LIB_WXRICHTEXT += cfg.makeLibName('richtext')
        conf.env.LIB_WXRICHTEXT += cfg.makeLibName('adv')

        _copyEnvGroup(conf.env, '_WX', '_WXMEDIA')
        conf.env.LIB_WXMEDIA += cfg.makeLibName('media')

        _copyEnvGroup(conf.env, '_WX', '_WXRIBBON')
        conf.env.LIB_WXRIBBON += cfg.makeLibName('ribbon')

        _copyEnvGroup(conf.env, '_WX', '_WXPROPGRID')
        conf.env.LIB_WXPROPGRID += cfg.makeLibName('propgrid')

        _copyEnvGroup(conf.env, '_WX', '_WXAUI')
        conf.env.LIB_WXAUI += cfg.makeLibName('aui')

        # ** Add code for new modules here (and below for non-MSW)

        # tweak the PYEXT compile and link flags if making a --debug build
        if conf.env.debug:
            for listname in ['CFLAGS_PYEXT', 'CXXFLAGS_PYEXT']:
                lst = conf.env[listname]
                for opt in '/Ox /MD /DNDEBUG'.split():
                    try:
                        lst.remove(opt)
                    except ValueError:
                        pass
                # NOTE: For --debug builds the /Z7 flag is used so the debug
                # info will be in each object file instead of a separate PDB
                # file. This will result in much faster builds since VC won't
                # have to serialize access to the .pdb file. OTOH, separate
                # PDB files are generated for the --msvc_relwithdebug option,
                # which is handled below in the makeETGRule() function.
                lst[1:1] = '/Od /MDd /Z7 /D_DEBUG'.split()

            conf.env['LINKFLAGS_PYEXT'].append('/DEBUG')
            conf.env['LIB_PYEXT'][0] += '_d'


    else:
        # Configuration stuff for non-Windows ports using wx-config
        conf.env.CFLAGS_WX   = list()
        conf.env.CXXFLAGS_WX = list()
        conf.env.CFLAGS_WXPY   = list()
        conf.env.CXXFLAGS_WXPY = list()

        # finish configuring the Config object
        conf.env.wx_config = conf.options.wx_config
        cfg.finishSetup(conf.env.wx_config, conf.env.debug)

        # Check wx-config exists and fetch some values from it
        rpath = ' --no-rpath' if not conf.options.no_magic else ''
        conf.check_cfg(path=conf.options.wx_config, package='',
                       args='--cxxflags --libs core,net' + rpath,
                       uselib_store='WX', mandatory=True)

        # Run it again with different libs options to get different
        # sets of flags stored to use with varous extension modules below.
        conf.check_cfg(path=conf.options.wx_config, package='',
                       args='--cxxflags --libs adv,core,net' + rpath,
                       uselib_store='WXADV', mandatory=True)

        libname = '' if cfg.MONOLITHIC else 'stc,' # workaround bug in wx-config
        conf.check_cfg(path=conf.options.wx_config, package='',
                       args=('--cxxflags --libs %score,net' % libname) + rpath,
                       uselib_store='WXSTC', mandatory=True)

        conf.check_cfg(path=conf.options.wx_config, package='',
                       args='--cxxflags --libs html,core,net' + rpath,
                       uselib_store='WXHTML', mandatory=True)

        conf.check_cfg(path=conf.options.wx_config, package='',
                       args='--cxxflags --libs gl,core,net' + rpath,
                       uselib_store='WXGL', mandatory=True)

        conf.check_cfg(path=conf.options.wx_config, package='',
                       args='--cxxflags --libs webview,core,net' + rpath,
                       uselib_store='WXWEBVIEW', mandatory=True)

        if isDarwin:
            conf.check_cfg(path=conf.options.wx_config, package='',
                           args='--cxxflags --libs core,net' + rpath,
                           uselib_store='WXWEBKIT', mandatory=True)

        conf.check_cfg(path=conf.options.wx_config, package='',
                       args='--cxxflags --libs xml,core,net' + rpath,
                       uselib_store='WXXML', mandatory=True)

        conf.check_cfg(path=conf.options.wx_config, package='',
                       args='--cxxflags --libs xrc,xml,core,net' + rpath,
                       uselib_store='WXXRC', mandatory=True)

        libname = '' if cfg.MONOLITHIC else 'richtext,' # workaround bug in wx-config
        conf.check_cfg(path=conf.options.wx_config, package='',
                       args='--cxxflags --libs %score,net' % libname + rpath,
                       uselib_store='WXRICHTEXT', mandatory=True)

        conf.check_cfg(path=conf.options.wx_config, package='',
                       args='--cxxflags --libs media,core,net' + rpath,
                       uselib_store='WXMEDIA', mandatory=True)

        conf.check_cfg(path=conf.options.wx_config, package='',
                       args='--cxxflags --libs ribbon,core,net' + rpath,
                       uselib_store='WXRIBBON', mandatory=True)

        conf.check_cfg(path=conf.options.wx_config, package='',
                       args='--cxxflags --libs propgrid,core' + rpath,
                       uselib_store='WXPROPGRID', mandatory=True)

        conf.check_cfg(path=conf.options.wx_config, package='',
                       args='--cxxflags --libs aui,core' + rpath,
                       uselib_store='WXAUI', mandatory=True)

        # ** Add code for new modules here


        # NOTE: This assumes that if the platform is not win32 (from the test
        # above) and not darwin then we must be using the GTK2 or GTK3 port of
        # wxWidgets.  If we ever support other ports then this code will need
        # to be adjusted.
        if not isDarwin:
            if conf.options.gtk2:
                conf.options.gtk3 = False
            if conf.options.gtk2:
                gtkflags = os.popen('pkg-config gtk+-2.0 --cflags', 'r').read()[:-1]
            else:
                gtkflags = os.popen('pkg-config gtk+-3.0 --cflags', 'r').read()[:-1]

            conf.env.CFLAGS_WX   += gtkflags.split()
            conf.env.CXXFLAGS_WX += gtkflags.split()

        # clear out Python's default NDEBUG and make sure it is undef'd too just in case
        if 'NDEBUG' in conf.env.DEFINES_PYEXT:
            conf.env.DEFINES_PYEXT.remove('NDEBUG')
        conf.env.CFLAGS_WXPY.append('-UNDEBUG')
        conf.env.CXXFLAGS_WXPY.append('-UNDEBUG')

        # Add basic debug info for all builds
        conf.env.CFLAGS_WXPY.append('-g')
        conf.env.CXXFLAGS_WXPY.append('-g')

=== debian/changelog ===
wxpython4.0 (4.0.1+dfsg-2) unstable; urgency=medium

  * Rebuild against GTK+ 3 build of wxwidgets3.0
  * Enable build/packaging of wx.html2 (webview) submodule
  * Update package descriptions to avoid duplicate description warnings
  * Move standalone license paragraphs to end of copyright file

 -- Scott Talbert <swt@techie.net>  Sat, 24 Mar 2018 23:17:29 -0400

wxpython4.0 (4.0.1+dfsg-1) unstable; urgency=medium

  * Update to upstream version '4.0.1+dfsg'
  * Remove verbatim copies of GPL/LGPL from copyright file
  * Fix all shellcheck issues with repack.sh
  * Enable hardening
  * Update debian/copyright file

 -- Scott Talbert <swt@techie.net>  Mon, 05 Feb 2018 22:54:25 -0500

wxpython4.0 (4.0.0+dfsg-1) unstable; urgency=medium

  * Initial packaging based on wxpython3.0 (Closes: #888554)
  * Python 2 version is included to aid developers in porting from wxPython
    Classic to Phoenix

 -- Scott Talbert <swt@techie.net>  Thu, 01 Feb 2018 22:30:22 -0500

=== debian/control ===
Source: wxpython4.0
Section: python
Priority: optional
Maintainer: wxWidgets Maintainers <freewx-maint@lists.alioth.debian.org>
Uploaders: Olly Betts <olly@survex.com>, Scott Talbert <swt@techie.net>
Build-Depends:
    debhelper (>= 9),
    dh-python,
    doxygen,
    libgtk-3-dev,
    libwxgtk3.0-gtk3-dev,
    libwxgtk-media3.0-gtk3-dev,
    libwxgtk-webview3.0-gtk3-dev,
    python-all,
    python-all-dev,
    python-requests,
    python-setuptools,
    python-sip-dev,
    python3-all,
    python3-all-dev,
    python3-requests,
    python3-setuptools,
    python3-sip-dev,
Standards-Version: 4.1.3
Vcs-Git: https://salsa.debian.org/freewx-team/wxpython4.0.git
Vcs-Browser: https://salsa.debian.org/freewx-team/wxpython4.0
Homepage: https://www.wxpython.org/

Package: python-wxgtk4.0
Architecture: any
Depends: python-sip, python-six, ${python:Depends}, ${shlibs:Depends}, ${misc:Depends}
Suggests: wx3.0-doc
Provides: ${python:Provides}
Description: Python interface to the wxWidgets Cross-platform C++ GUI toolkit
 wxWidgets (formerly known as wxWindows) is a class library for C++ providing
 GUI components and other facilities on several popular platforms (and some
 unpopular ones as well).
 .
 This package provides a Python interface to the wxGTK library and the
 wxPython runtime support libraries.  This is the Phoenix reimplementation of
 wxPython.

Package: python-wxgtk-media4.0
Architecture: any
Depends: python-wxgtk4.0, ${python:Depends}, ${shlibs:Depends}, ${misc:Depends}
Provides: ${python:Provides}
Description: Python interface to the wxWidgets Cross-platform C++ GUI toolkit (wx.media)
 wxWidgets (formerly known as wxWindows) is a class library for C++ providing
 GUI components and other facilities on several popular platforms (and some
 unpopular ones as well).
 .
 This package provides a Python interface to wxMediaCtrl.  This is the Phoenix
 reimplementation of wxPython.

Package: python-wxgtk-webview4.0
Architecture: any
Depends: python-wxgtk4.0, ${python:Depends}, ${shlibs:Depends}, ${misc:Depends}
Provides: ${python:Provides}
Description: Python interface to the wxWidgets Cross-platform C++ GUI toolkit (wx.html2)
 wxWidgets (formerly known as wxWindows) is a class library for C++ providing
 GUI components and other facilities on several popular platforms (and some
 unpopular ones as well).
 .
 This package provides a Python interface to wxWebView.  This is the Phoenix
 reimplementation of wxPython.

Package: python3-wxgtk4.0
Architecture: any
Depends: python3-sip, python3-six, ${python3:Depends}, ${shlibs:Depends}, ${misc:Depends}
Suggests: wx3.0-doc
Provides: ${python3:Provides}
Description: Python 3 interface to the wxWidgets Cross-platform C++ GUI toolkit
 wxWidgets (formerly known as wxWindows) is a class library for C++ providing
 GUI components and other facilities on several popular platforms (and some
 unpopular ones as well).
 .
 This package provides a Python 3 interface to the wxGTK library and the
 wxPython runtime support libraries.  This is the Phoenix reimplementation of
 wxPython.

Package: python3-wxgtk-media4.0
Architecture: any
Depends: python3-wxgtk4.0, ${python3:Depends}, ${shlibs:Depends}, ${misc:Depends}
Provides: ${python3:Provides}
Description: Python 3 interface to the wxWidgets Cross-platform C++ GUI toolkit (wx.media)
 wxWidgets (formerly known as wxWindows) is a class library for C++ providing
 GUI components and other facilities on several popular platforms (and some
 unpopular ones as well).
 .
 This package provides a Python 3 interface to wxMediaCtrl.  This is the Phoenix
 reimplementation of wxPython.

Package: python3-wxgtk-webview4.0
Architecture: any
Depends: python3-wxgtk4.0, ${python3:Depends}, ${shlibs:Depends}, ${misc:Depends}
Provides: ${python3:Provides}
Description: Python 3 interface to the wxWidgets Cross-platform C++ GUI toolkit (wx.html2)
 wxWidgets (formerly known as wxWindows) is a class library for C++ providing
 GUI components and other facilities on several popular platforms (and some
 unpopular ones as well).
 .
 This package provides a Python 3 interface to wxWebView.  This is the Phoenix
 reimplementation of wxPython.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
include /usr/share/dpkg/default.mk

export DOXYGEN=/usr/bin/doxygen
export SIP=/usr/bin/sip
export PYBUILD_SYSTEM=custom
export PYBUILD_BUILD_ARGS_python2=python{version} -u build.py dox touch etg --nodoc sip build_py --use_syswx --gtk3 bdist_egg
export PYBUILD_BUILD_ARGS_python3=python{version} -u build.py dox touch etg --nodoc sip build_py --use_syswx --gtk3
export PYBUILD_CLEAN_ARGS=python{version} build.py clean
export PYBUILD_BEFORE_INSTALL=mkdir -p {destdir}{install_dir}
export PYBUILD_INSTALL_ARGS_python2=easy_install -m -d {destdir}{install_dir} -Z dist/*.egg
export PYBUILD_INSTALL_ARGS_python3=python{version} build.py install_py --destdir={destdir} --extra_setup="--install-layout=deb"
export PYBUILD_DISABLE=configure test

%:
	dh $@ --with python2,python3 --buildsystem=pybuild

override_dh_install:
	dh_install
	# These are packaged in the -media subpackage:
	rm -f debian/python-wxgtk4.0/usr/lib/python*/dist-packages/wxPython*/wx/_media.*so \
	      debian/python-wxgtk4.0/usr/lib/python*/dist-packages/wxPython*/wx/media.py* \
	      debian/python3-wxgtk4.0/usr/lib/python*/dist-packages/wx/_media.*so \
	      debian/python3-wxgtk4.0/usr/lib/python*/dist-packages/wx/media.py*
	# These are packaged in the -webview subpackage:
	rm -f debian/python-wxgtk4.0/usr/lib/python*/dist-packages/wxPython*/wx/_html2.*so \
	      debian/python-wxgtk4.0/usr/lib/python*/dist-packages/wxPython*/wx/html2.py* \
	      debian/python3-wxgtk4.0/usr/lib/python*/dist-packages/wx/_html2.*so \
	      debian/python3-wxgtk4.0/usr/lib/python*/dist-packages/wx/html2.py*

=== debian/watch ===
version=3
opts=dversionmangle=s/\+dfsg.*$//,pgpmode=auto \
  https://pypi.python.org/packages/source/w/wxPython/ wxPython-(.+)\.tar\.gz debian debian/repack.sh

## wxpython4.0 4.0.4+dfsg

=== requirements.txt ===
--- 
+++ 
@@ -10,3 +10,4 @@
 pytest-xdist
 pytest-timeout
 numpy
+pillow

=== wscript ===
--- 
+++ 
@@ -3,7 +3,7 @@
 #  WAF script for building and installing the wxPython extension modules.
 #
 # Author:      Robin Dunn
-# Copyright:   (c) 2013 - 2017 by Total Control Software
+# Copyright:   (c) 2013 - 2018 by Total Control Software
 # License:     wxWindows License
 #-----------------------------------------------------------------------------
 
@@ -30,7 +30,7 @@
     if isWindows:
         opt.load('msvc')
     else:
-        opt.load('compiler_cc compiler_cxx')
+        opt.load('compiler_c compiler_cxx')
     opt.load('python')
 
     opt.add_option('--debug', dest='debug', action='store_true', default=False,
@@ -53,14 +53,6 @@
     opt.add_option('--msvc_arch', dest='msvc_arch', default='x86', action='store',
                    help='The architecture to target for MSVC builds. Supported values '
                    'are: "x86" or "x64"')
-    #opt.add_option('--msvc_ver', dest='msvc_ver', default='9.0', action='store',
-    #               help='The MSVC version to use for the build, if multiple versions are '
-    #               'installed. Currently supported values are: "9.0" or "10.0"')
-
-    # TODO: The waf msvc tool has --msvc_version and --msvc_target options
-    # already. We should just switch to those instead of adding our own
-    # option names...
-
     opt.add_option('--msvc_relwithdebug', dest='msvc_relwithdebug', action='store_true', default=False,
                    help='Turn on debug info for release builds for MSVC builds.')
 
@@ -74,11 +66,27 @@
         # Python to know what version of the compiler to use.
         import distutils.msvc9compiler
         msvc_version = str( distutils.msvc9compiler.get_build_version() )
+
+        # When building for Python 3.7 the msvc_version returned will be
+        # "14.1" as that is the version of the BasePlatformToolkit that stock
+        # Python 3.7 was built with, a.k.a v141, which is the default in
+        # Visual Studio 2017. However, waf is using "msvc 15.0" to designate
+        # that version rather than "14.1" so we'll need to catch that case and
+        # fix up the msvc_version accordingly.
+        if msvc_version == "14.1" and sys.version_info >= (3,7):
+            ##msvc_version = '15.0'
+
+            # On the other hand, microsoft says that v141 and v140 (Visual
+            # Studio 2015) are binary compatible, so for now let's just drop
+            # it back to "14.0" until I get all the details worked out for
+            # using VS 2017 everywhere for Python 3.7.
+            msvc_version = '14.0'
+
         conf.env['MSVC_VERSIONS'] = ['msvc ' + msvc_version]
         conf.env['MSVC_TARGETS'] = [conf.options.msvc_arch]
         conf.load('msvc')
     else:
-        conf.load('compiler_cc compiler_cxx')
+        conf.load('compiler_c compiler_cxx')
 
     if conf.options.python:
         conf.env.PYTHON = conf.options.python
@@ -96,7 +104,7 @@
     conf.env.msvc_relwithdebug = conf.options.msvc_relwithdebug
 
     # Ensure that the headers in siplib and Phoenix's src dir can be found
-    conf.env.INCLUDES_WXPY = ['sip/siplib', 'src']
+    conf.env.INCLUDES_WXPY = ['sip/siplib', 'wx/include', 'src']
 
     if isWindows:
         # Windows/MSVC specific stuff
@@ -149,6 +157,7 @@
         conf.env.LIB_WXAUI += cfg.makeLibName('aui')
 
         # ** Add code for new modules here (and below for non-MSW)
+
 
         # tweak the PYEXT compile and link flags if making a --debug build
         if conf.env.debug:
@@ -186,90 +195,76 @@
         rpath = ' --no-rpath' if not conf.options.no_magic else ''
         conf.check_cfg(path=conf.options.wx_config, package='',
                        args='--cxxflags --libs core,net' + rpath,
-                       uselib_store='WX', mandatory=True)
+                       uselib_store='WX', mandatory=True,
+                       msg='Finding libs for WX')
 
         # Run it again with different libs options to get different
         # sets of flags stored to use with varous extension modules below.
         conf.check_cfg(path=conf.options.wx_config, package='',
                        args='--cxxflags --libs adv,core,net' + rpath,
-                       uselib_store='WXADV', mandatory=True)
+                       uselib_store='WXADV', mandatory=True,
+                       msg='Finding libs for WXADV')
 
         libname = '' if cfg.MONOLITHIC else 'stc,' # workaround bug in wx-config
         conf.check_cfg(path=conf.options.wx_config, package='',
                        args=('--cxxflags --libs %score,net' % libname) + rpath,
-                       uselib_store='WXSTC', mandatory=True)
+                       uselib_store='WXSTC', mandatory=True,
+                       msg='Finding libs for WXSTC')
 
         conf.check_cfg(path=conf.options.wx_config, package='',
                        args='--cxxflags --libs html,core,net' + rpath,
-                       uselib_store='WXHTML', mandatory=True)
+                       uselib_store='WXHTML', mandatory=True,
+                       msg='Finding libs for WXHTML')
 
         conf.check_cfg(path=conf.options.wx_config, package='',
                        args='--cxxflags --libs gl,core,net' + rpath,
-                       uselib_store='WXGL', mandatory=True)
+                       uselib_store='WXGL', mandatory=True,
+                       msg='Finding libs for WXGL')
 
         conf.check_cfg(path=conf.options.wx_config, package='',
                        args='--cxxflags --libs webview,core,net' + rpath,
-                       uselib_store='WXWEBVIEW', mandatory=True)
+                       uselib_store='WXWEBVIEW', mandatory=True,
+                       msg='Finding libs for WXWEBVIEW')
 
         if isDarwin:
             conf.check_cfg(path=conf.options.wx_config, package='',
                            args='--cxxflags --libs core,net' + rpath,
-                           uselib_store='WXWEBKIT', mandatory=True)
+                           uselib_store='WXWEBKIT', mandatory=True,
+                           msg='Finding libs for WXWEBKIT')
 
         conf.check_cfg(path=conf.options.wx_config, package='',
                        args='--cxxflags --libs xml,core,net' + rpath,
-                       uselib_store='WXXML', mandatory=True)
+                       uselib_store='WXXML', mandatory=True,
+                       msg='Finding libs for WXXML')
 
         conf.check_cfg(path=conf.options.wx_config, package='',
                        args='--cxxflags --libs xrc,xml,core,net' + rpath,
-                       uselib_store='WXXRC', mandatory=True)
+                       uselib_store='WXXRC', mandatory=True,
+                       msg='Finding libs for WXXRC')
 
         libname = '' if cfg.MONOLITHIC else 'richtext,' # workaround bug in wx-config
         conf.check_cfg(path=conf.options.wx_config, package='',
                        args='--cxxflags --libs %score,net' % libname + rpath,
-                       uselib_store='WXRICHTEXT', mandatory=True)
+                       uselib_store='WXRICHTEXT', mandatory=True,
+                       msg='Finding libs for WXRICHTEXT')
 
         conf.check_cfg(path=conf.options.wx_config, package='',
                        args='--cxxflags --libs media,core,net' + rpath,
-                       uselib_store='WXMEDIA', mandatory=True)
+                       uselib_store='WXMEDIA', mandatory=True,
+                       msg='Finding libs for WXMEDIA')
 
         conf.check_cfg(path=conf.options.wx_config, package='',
                        args='--cxxflags --libs ribbon,core,net' + rpath,
-                       uselib_store='WXRIBBON', mandatory=True)
+                       uselib_store='WXRIBBON', mandatory=True,
+                       msg='Finding libs for WXRIBBON')
 
         conf.check_cfg(path=conf.options.wx_config, package='',
                        args='--cxxflags --libs propgrid,core' + rpath,
-                       uselib_store='WXPROPGRID', mandatory=True)
+                       uselib_store='WXPROPGRID', mandatory=True,
+                       msg='Finding libs for WXPROPGRID')
 
         conf.check_cfg(path=conf.options.wx_config, package='',
                        args='--cxxflags --libs aui,core' + rpath,
-                       uselib_store='WXAUI', mandatory=True)
-
-        # ** Add code for new modules here
-
-
-        # NOTE: This assumes that if the platform is not win32 (from the test
-        # above) and not darwin then we must be using the GTK2 or GTK3 port of
-        # wxWidgets.  If we ever support other ports then this code will need
-        # to be adjusted.
-        if not isDarwin:
-            if conf.options.gtk2:
-                conf.options.gtk3 = False
-            if conf.options.gtk2:
-                gtkflags = os.popen('pkg-config gtk+-2.0 --cflags', 'r').read()[:-1]
-            else:
-                gtkflags = os.popen('pkg-config gtk+-3.0 --cflags', 'r').read()[:-1]
-
-            conf.env.CFLAGS_WX   += gtkflags.split()
-            conf.env.CXXFLAGS_WX += gtkflags.split()
-
-        # clear out Python's default NDEBUG and make sure it is undef'd too just in case
-        if 'NDEBUG' in conf.env.DEFINES_PYEXT:
-            conf.env.DEFINES_PYEXT.remove('NDEBUG')
-        conf.env.CFLAGS_WXPY.append('-UNDEBUG')
-        conf.env.CXXFLAGS_WXPY.append('-UNDEBUG')
-
-        # Add basic debug info for all builds
-        conf.env.CFLAGS_WXPY.append('-g')
-        conf.env.CXXFLAGS_WXPY.append('-g')
-
+                       uselib_store='WXAUI', mandatory=True,
+                       msg='Finding libs for WXAUI')
+

=== debian/changelog ===
wxpython4.0 (4.0.4+dfsg-2) unstable; urgency=medium

  * d/patches: Fix FTBFS with SIP 4.19.14 (Closes: #924856)

 -- Scott Talbert <swt@techie.net>  Mon, 01 Apr 2019 22:41:28 -0400

wxpython4.0 (4.0.4+dfsg-1) unstable; urgency=medium

  * Update d/copyright and d/watch to use uscan repack mechanism vs. repack.sh
  * New upstream version 4.0.4 (Closes: #919144)
  * d/patches: remove waf patches (no longer needed)
  * d/patches: update unbundle-sip patch for new upstream release
  * d/patches: add patch to fix wxJoystick stubs (Closes: #892237)
  * d/control: update standards version to 4.3.0 (no changes needed)
  * d/control: add python[3]-pil as a dependency (required in 4.0.4)
  * Enable tests during build but for information only (not gating)
  * d/copyright: remove now-unused paragraphs due to removed files

 -- Scott Talbert <swt@techie.net>  Fri, 25 Jan 2019 18:19:15 -0500

wxpython4.0 (4.0.1+dfsg-6) unstable; urgency=medium

  * d/control: Use sip substitution variables for Depends (Closes: #903595)

 -- Scott Talbert <swt@techie.net>  Thu, 12 Jul 2018 18:20:08 -0400

wxpython4.0 (4.0.1+dfsg-5) unstable; urgency=medium

  * Cherry-pick waf 2.0.7 updates to fix Python 3.7 FTBFS
  * d/control: Update standards version to 4.1.4 (no changes needed)

 -- Scott Talbert <swt@techie.net>  Tue, 03 Jul 2018 19:47:38 -0400

wxpython4.0 (4.0.1+dfsg-4) unstable; urgency=medium

  * Update team email address due to alioth retirement (Closes: #899942)

 -- Scott Talbert <swt@techie.net>  Tue, 29 May 2018 21:20:05 -0400

wxpython4.0 (4.0.1+dfsg-3) unstable; urgency=medium

  * Work around removal of easy_install binary (Closes: #895516)
  * Update descriptions and add README.Debian about using Python 2 packages
    (Closes: #895083)

 -- Scott Talbert <swt@techie.net>  Wed, 09 May 2018 21:19:27 -0400

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: wxpython4.0
 Section: python
 Priority: optional
-Maintainer: wxWidgets Maintainers <freewx-maint@lists.alioth.debian.org>
+Maintainer: wxWidgets Maintainers <team+wx@tracker.debian.org>
 Uploaders: Olly Betts <olly@survex.com>, Scott Talbert <swt@techie.net>
 Build-Depends:
     debhelper (>= 9),
@@ -13,22 +13,36 @@
     libwxgtk-webview3.0-gtk3-dev,
     python-all,
     python-all-dev,
+    python-numpy,
+    python-pil,
+    python-pypdf2,
+    python-pytest,
+    python-pytest-timeout,
+    python-pytest-xdist,
     python-requests,
     python-setuptools,
     python-sip-dev,
     python3-all,
     python3-all-dev,
+    python3-numpy,
+    python3-pil,
+    python3-pypdf2,
+    python3-pytest,
+    python3-pytest-timeout,
+    python3-pytest-xdist,
     python3-requests,
     python3-setuptools,
     python3-sip-dev,
-Standards-Version: 4.1.3
+    xauth,
+    xvfb,
+Standards-Version: 4.3.0
 Vcs-Git: https://salsa.debian.org/freewx-team/wxpython4.0.git
 Vcs-Browser: https://salsa.debian.org/freewx-team/wxpython4.0
 Homepage: https://www.wxpython.org/
 
 Package: python-wxgtk4.0
 Architecture: any
-Depends: python-sip, python-six, ${python:Depends}, ${shlibs:Depends}, ${misc:Depends}
+Depends: python-pil, python-six, ${python:Depends}, ${shlibs:Depends}, ${misc:Depends}, ${sip:Depends}
 Suggests: wx3.0-doc
 Provides: ${python:Provides}
 Description: Python interface to the wxWidgets Cross-platform C++ GUI toolkit
@@ -38,7 +52,8 @@
  .
  This package provides a Python interface to the wxGTK library and the
  wxPython runtime support libraries.  This is the Phoenix reimplementation of
- wxPython.
+ wxPython.  NOTE: this package is not importable by default and is intended
+ only for porting.  See README.Debian for more information.
 
 Package: python-wxgtk-media4.0
 Architecture: any
@@ -50,7 +65,8 @@
  unpopular ones as well).
  .
  This package provides a Python interface to wxMediaCtrl.  This is the Phoenix
- reimplementation of wxPython.
+ reimplementation of wxPython.  NOTE: this package is not importable by default
+ and is intended only for porting.  See README.Debian for more information.
 
 Package: python-wxgtk-webview4.0
 Architecture: any
@@ -62,11 +78,12 @@
  unpopular ones as well).
  .
  This package provides a Python interface to wxWebView.  This is the Phoenix
- reimplementation of wxPython.
+ reimplementation of wxPython.  NOTE: this package is not importable by default
+ and is intended only for porting.  See README.Debian for more information.
 
 Package: python3-wxgtk4.0
 Architecture: any
-Depends: python3-sip, python3-six, ${python3:Depends}, ${shlibs:Depends}, ${misc:Depends}
+Depends: python3-pil, python3-six, ${python3:Depends}, ${shlibs:Depends}, ${misc:Depends}, ${sip3:Depends}
 Suggests: wx3.0-doc
 Provides: ${python3:Provides}
 Description: Python 3 interface to the wxWidgets Cross-platform C++ GUI toolkit

=== debian/rules ===
--- 
+++ 
@@ -10,12 +10,22 @@
 export PYBUILD_BUILD_ARGS_python3=python{version} -u build.py dox touch etg --nodoc sip build_py --use_syswx --gtk3
 export PYBUILD_CLEAN_ARGS=python{version} build.py clean
 export PYBUILD_BEFORE_INSTALL=mkdir -p {destdir}{install_dir}
-export PYBUILD_INSTALL_ARGS_python2=easy_install -m -d {destdir}{install_dir} -Z dist/*.egg
+export PYBUILD_INSTALL_ARGS_python2=python{version} -m easy_install -m -d {destdir}{install_dir} -Z dist/*.egg
 export PYBUILD_INSTALL_ARGS_python3=python{version} build.py install_py --destdir={destdir} --extra_setup="--install-layout=deb"
-export PYBUILD_DISABLE=configure test
+SKIP_TESTS='not (display_Tests or glcanvas_Tests or mousemanager_Tests or numdlg_Tests or uiaction_MouseTests or uiaction_KeyboardTests or unichar_Tests or valtext_Tests or test_frameRestore or test_grid_pi)'
+export PYBUILD_BEFORE_TEST=mv wx wx.orig
+export PYBUILD_TEST_ARGS=PYTHONPATH=build/lib.$(DEB_HOST_ARCH_OS)-$(DEB_HOST_ARCH)-{version} PYTHONDONTWRITEBYTECODE=1 xvfb-run -a python{version} -m pytest -v --boxed --timeout=60 -k $(SKIP_TESTS) unittests || true
+export PYBUILD_AFTER_TEST=mv wx.orig wx
+export PYBUILD_DISABLE=configure
 
 %:
 	dh $@ --with python2,python3 --buildsystem=pybuild
+
+override_dh_auto_test:
+
+override_dh_auto_install:
+	dh_auto_install
+	dh_auto_test
 
 override_dh_install:
 	dh_install
@@ -29,3 +39,11 @@
 	      debian/python-wxgtk4.0/usr/lib/python*/dist-packages/wxPython*/wx/html2.py* \
 	      debian/python3-wxgtk4.0/usr/lib/python*/dist-packages/wx/_html2.*so \
 	      debian/python3-wxgtk4.0/usr/lib/python*/dist-packages/wx/html2.py*
+
+override_dh_python2:
+	dh_python2
+	dh_sip
+
+override_dh_python3:
+	dh_python3
+	dh_sip3

## wxpython4.0 4.0.6+dfsg

=== wscript ===
--- 
+++ 
@@ -92,12 +92,14 @@
         conf.env.PYTHON = conf.options.python
     conf.load('python')
     conf.check_python_version(minver=(2,7,0))
-    if isWindows:
+    if isWindows or isDarwin:
         # Search for the Python headers without doing some stuff that could
-        # incorrectly fail on Windows. See my_check_python_headers below.
+        # incorrectly fail on Windows. Seems to help on Darwin too. See
+        # my_check_python_headers below.
+        # TODO: Check if it can/should be used on other platforms too.
         conf.my_check_python_headers()
     else:
-        conf.check_python_headers()
+        conf.check_python_headers(features='pyext')
 
     # fetch and save the debug options
     conf.env.debug = conf.options.debug
@@ -181,6 +183,9 @@
 
 
     else:
+        # TODO: Double-check that this works when using an installed wxWidgets
+        wxConfigDir = cfg.findWxConfigDir(conf.options.wx_config)
+
         # Configuration stuff for non-Windows ports using wx-config
         conf.env.CFLAGS_WX   = list()
         conf.env.CXXFLAGS_WX = list()
@@ -216,13 +221,21 @@
                        uselib_store='WXHTML', mandatory=True,
                        msg='Finding libs for WXHTML')
 
-        conf.check_cfg(path=conf.options.wx_config, package='',
-                       args='--cxxflags --libs gl,core,net' + rpath,
+        if cfg.checkSetup(wxConfigDir, 'wxUSE_GLCANVAS'):
+            gl_libs = '--libs gl,core,net'
+        else:
+            gl_libs = '--libs core,net'
+        conf.check_cfg(path=conf.options.wx_config, package='',
+                       args='--cxxflags ' + gl_libs + rpath,
                        uselib_store='WXGL', mandatory=True,
                        msg='Finding libs for WXGL')
 
-        conf.check_cfg(path=conf.options.wx_config, package='',
-                       args='--cxxflags --libs webview,core,net' + rpath,
+        if cfg.checkSetup(wxConfigDir, 'wxUSE_WEBVIEW'):
+            wv_libs = '--libs webview,core,net'
+        else:
+            wv_libs = '--libs core,net'
+        conf.check_cfg(path=conf.options.wx_config, package='',
+                       args='--cxxflags ' + wv_libs + rpath,
                        uselib_store='WXWEBVIEW', mandatory=True,
                        msg='Finding libs for WXWEBVIEW')
 
@@ -248,23 +261,12 @@
                        uselib_store='WXRICHTEXT', mandatory=True,
                        msg='Finding libs for WXRICHTEXT')
 
-        conf.check_cfg(path=conf.options.wx_config, package='',
-                       args='--cxxflags --libs media,core,net' + rpath,
+        if cfg.checkSetup(wxConfigDir, 'wxUSE_MEDIACTRL'):
+            mc_libs = '--libs media,core,net'
+        else:
+            mc_libs = '--libs core,net'
+        conf.check_cfg(path=conf.options.wx_config, package='',
+                       args='--cxxflags ' + mc_libs + rpath,
                        uselib_store='WXMEDIA', mandatory=True,
                        msg='Finding libs for WXMEDIA')
 
-        conf.check_cfg(path=conf.options.wx_config, package='',
-                       args='--cxxflags --libs ribbon,core,net' + rpath,
-                       uselib_store='WXRIBBON', mandatory=True,
-                       msg='Finding libs for WXRIBBON')
-
-        conf.check_cfg(path=conf.options.wx_config, package='',
-                       args='--cxxflags --libs propgrid,core' + rpath,
-                       uselib_store='WXPROPGRID', mandatory=True,
-                       msg='Finding libs for WXPROPGRID')
-
-        conf.check_cfg(path=conf.options.wx_config, package='',
-                       args='--cxxflags --libs aui,core' + rpath,
-                       uselib_store='WXAUI', mandatory=True,
-                       msg='Finding libs for WXAUI')
-

=== debian/changelog ===
wxpython4.0 (4.0.6+dfsg-2) unstable; urgency=medium

  * Use debhelper-compat instead of debian/compat
  * Drop Python 2 subpackages (not used by anything in Debian)

 -- Scott Talbert <swt@techie.net>  Fri, 23 Aug 2019 18:22:31 -0400

wxpython4.0 (4.0.6+dfsg-1) unstable; urgency=medium

  * d/rules: Enable verbose building with waf
  * d/copyright: Remove more now-unused paragraphs/licenses for removed files
  * d/patches: Add patch to fix spelling errors in binaries
  * d/control: Update debhelper compat version to 12
  * d/upstream/signing-key.asc: Re-export without extra signatures
  * d/control: Tighten Build-Depends on sip-dev (Closes: #929312)
  * d/control: Update Standards Version to 4.4.0 (no changes needed)
  * Update to new upstream release 4.0.6; remove upstream patches

 -- Scott Talbert <swt@techie.net>  Tue, 09 Jul 2019 19:37:03 -0400

=== debian/control ===
Source: wxpython4.0
Section: python
Priority: optional
Maintainer: wxWidgets Maintainers <team+wx@tracker.debian.org>
Uploaders: Olly Betts <olly@survex.com>, Scott Talbert <swt@techie.net>
Build-Depends:
    debhelper-compat (= 12),
    dh-python,
    doxygen,
    libgtk-3-dev,
    libwxgtk3.0-gtk3-dev,
    libwxgtk-media3.0-gtk3-dev,
    libwxgtk-webview3.0-gtk3-dev,
    python3-all,
    python3-all-dev,
    python3-numpy,
    python3-pil,
    python3-pypdf2,
    python3-pytest,
    python3-pytest-timeout,
    python3-pytest-xdist,
    python3-requests,
    python3-setuptools,
    python3-sip-dev (>= 4.19.1),
    xauth,
    xvfb,
Standards-Version: 4.4.0
Vcs-Git: https://salsa.debian.org/freewx-team/wxpython4.0.git
Vcs-Browser: https://salsa.debian.org/freewx-team/wxpython4.0
Homepage: https://www.wxpython.org/

Package: python3-wxgtk4.0
Architecture: any
Depends: python3-pil, python3-six, ${python3:Depends}, ${shlibs:Depends}, ${misc:Depends}, ${sip3:Depends}
Suggests: wx3.0-doc
Provides: ${python3:Provides}
Description: Python 3 interface to the wxWidgets Cross-platform C++ GUI toolkit
 wxWidgets (formerly known as wxWindows) is a class library for C++ providing
 GUI components and other facilities on several popular platforms (and some
 unpopular ones as well).
 .
 This package provides a Python 3 interface to the wxGTK library and the
 wxPython runtime support libraries.  This is the Phoenix reimplementation of
 wxPython.

Package: python3-wxgtk-media4.0
Architecture: any
Depends: python3-wxgtk4.0, ${python3:Depends}, ${shlibs:Depends}, ${misc:Depends}
Provides: ${python3:Provides}
Description: Python 3 interface to the wxWidgets Cross-platform C++ GUI toolkit (wx.media)
 wxWidgets (formerly known as wxWindows) is a class library for C++ providing
 GUI components and other facilities on several popular platforms (and some
 unpopular ones as well).
 .
 This package provides a Python 3 interface to wxMediaCtrl.  This is the Phoenix
 reimplementation of wxPython.

Package: python3-wxgtk-webview4.0
Architecture: any
Depends: python3-wxgtk4.0, ${python3:Depends}, ${shlibs:Depends}, ${misc:Depends}
Provides: ${python3:Provides}
Description: Python 3 interface to the wxWidgets Cross-platform C++ GUI toolkit (wx.html2)
 wxWidgets (formerly known as wxWindows) is a class library for C++ providing
 GUI components and other facilities on several popular platforms (and some
 unpopular ones as well).
 .
 This package provides a Python 3 interface to wxWebView.  This is the Phoenix
 reimplementation of wxPython.
